; canon-cded.lisp - a simple canon
(require :asdf)
(asdf:load-system :smolmidi)   ; https://thrig.me/src/smolmidi.git

(defun play (track duration pitch &key (velocity 96) (offset 0))
  (smolmidi:note-on track offset pitch velocity)
  (smolmidi:note-off track duration pitch 0))

(let ((pitch-list '(60 62 64 62)))
  (defun melody (&key (offset 0) (duration 96) (transpose 0))
    (let ((track (smolmidi:new-track)))
      (play track duration (+ transpose (first pitch-list))
            :offset (* offset duration))
      (loop for pitch in (rest pitch-list) do
            (play track duration (+ transpose pitch)))
      (loop repeat 7 do
            (loop for pitch in pitch-list do
                  (play track duration (+ transpose pitch))))
      track)))

(smolmidi:write-midi-file
  "out.midi" (list (melody)
                   (melody :offset 2 :transpose 12)))